#include "phoner.h"

// ==========================================================================
// class ICPhoner
void ICPhoner::MakeCall(LPCTSTR Number)
{
	static BYTE parms[] = VTS_BSTR;
	InvokeHelper(0x1, DISPATCH_METHOD, VT_EMPTY, NULL, parms, Number);
}

long ICPhoner::GetNumberOfCalls()
{
	long result;
	InvokeHelper(0x2, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, NULL);
	return result;
}

long ICPhoner::GetCallInfo(long CallID, long* Status, long* Direction, BSTR* CallerID, BSTR* CalledID)
{
	long result;
	static BYTE parms[] = VTS_I4 VTS_PI4 VTS_PI4 VTS_PBSTR VTS_PBSTR;
	InvokeHelper(0x3, DISPATCH_METHOD, VT_I4, (void*)&result, parms, CallID, Status, Direction, CallerID, CalledID);
	return result;
}

void ICPhoner::DisconnectCall(long CallID)
{
	static BYTE parms[] = VTS_I4;
	InvokeHelper(0x4, DISPATCH_METHOD, VT_EMPTY, NULL, parms, CallID);
}

void ICPhoner::SendSMS(LPCTSTR Number, LPCTSTR Msg)
{
	static BYTE parms[] = VTS_BSTR VTS_BSTR;
	InvokeHelper(0x5, DISPATCH_METHOD, VT_EMPTY, NULL, parms, Number, Msg);
}

void ICPhoner::AnswerCall(long CallID)
{
	static BYTE parms[] = VTS_I4;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_EMPTY, NULL, parms, CallID);
}

BOOL ICPhoner::GetWindowEnabled()
{
	BOOL result;
	InvokeHelper(0x8, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, NULL);
	return result;
}

void ICPhoner::SetWindowEnabled(BOOL bNewValue)
{
	static BYTE parms[] = VTS_BOOL;
	InvokeHelper(0x8, DISPATCH_PROPERTYPUT, VT_EMPTY, NULL, parms, bNewValue);
}

void ICPhoner::SendDTMF(long CallID, LPCTSTR DTMF)
{
	static BYTE parms[] = VTS_I4 VTS_BSTR;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_EMPTY, NULL, parms, CallID, DTMF);
}

CString ICPhoner::GetDisconnectReason(long CallID)
{
	CString result;
	static BYTE parms[] = VTS_I4;
	InvokeHelper(0xa, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, parms,	CallID);
	return result;
}

void ICPhoner::MakeCallOver(LPCTSTR Number, LPCTSTR MSN)
{
	static BYTE parms[] = VTS_BSTR VTS_BSTR;
	InvokeHelper(0xb, DISPATCH_METHOD, VT_EMPTY, NULL, parms, Number, MSN);
}

void ICPhoner::SendWAVE(long CallID, LPCTSTR FileName)
{
	static BYTE parms[] = VTS_I4 VTS_BSTR;
	InvokeHelper(0xc9, DISPATCH_METHOD, VT_EMPTY, NULL, parms, CallID, FileName);
}

void ICPhoner::GetState(long CallID, VARIANT* StateString)
{
	static BYTE parms[] = VTS_I4 VTS_PVARIANT;
	InvokeHelper(0xca, DISPATCH_METHOD, VT_EMPTY, NULL, parms, CallID, StateString);
}

void ICPhoner::GetDirection(long CallID, VARIANT* DirectionString)
{
	static BYTE parms[] = VTS_I4 VTS_PVARIANT;
	InvokeHelper(0xcb, DISPATCH_METHOD, VT_EMPTY, NULL, parms, CallID, DirectionString);
}

void ICPhoner::GetCallerID(long CallID, VARIANT* CallerID)
{
	static BYTE parms[] = VTS_I4 VTS_PVARIANT;
	InvokeHelper(0xcc, DISPATCH_METHOD, VT_EMPTY, NULL, parms, CallID, CallerID);
}

void ICPhoner::GetCalledID(long CallID, VARIANT* CalledID)
{
	static BYTE parms[] = VTS_I4 VTS_PVARIANT;
	InvokeHelper(0xcd, DISPATCH_METHOD, VT_EMPTY, NULL, parms, CallID, CalledID);
}

void ICPhoner::GetRecordedWAVE(long CallID, VARIANT* FileName)
{
	static BYTE parms[] = VTS_I4 VTS_PVARIANT;
	InvokeHelper(0xce, DISPATCH_METHOD, VT_EMPTY, NULL, parms, CallID, FileName);
}

// ==========================================================================
// class CPhonerEvent
IMPLEMENT_DYNCREATE(CPhonerEvent, CCmdTarget)

CPhonerEvent::CPhonerEvent()
{
	EnableAutomation();
	::AfxOleLockApp();

	m_pPhoner = NULL;
}

CPhonerEvent::~CPhonerEvent()
{
	::AfxOleUnlockApp();
}

void CPhonerEvent::SetPhonerInstance(CPhoner* pPhoner)
{
	m_pPhoner = pPhoner;
}

void CPhonerEvent::OnChangeState(int CallID)
{
	if (m_pPhoner)
		m_pPhoner->OnChangeState(CallID);
}

void CPhonerEvent::OnFilePlayed()
{
	if (m_pPhoner)
		m_pPhoner->OnFilePlayed();
}

void CPhonerEvent::OnDTMF(int CallID, BYTE Digit)
{
	if (m_pPhoner)
		m_pPhoner->OnDTMF(CallID, Digit);
}

void CPhonerEvent::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CPhonerEvent, CCmdTarget)
	//{{AFX_MSG_MAP(CPhonerEvent)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CPhonerEvent, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CPhonerEvent)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	    DISP_FUNCTION_ID(CPhonerEvent, "OnChangeState", 0x00000005, OnChangeState, VT_EMPTY, VTS_I4)
		DISP_FUNCTION_ID(CPhonerEvent, "OnFilePlayed",	0x000000C9, OnFilePlayed, VT_EMPTY, VTS_NONE)
		DISP_FUNCTION_ID(CPhonerEvent, "OnDTMF",		0x000000CA, OnDTMF, VT_EMPTY, VTS_I4 VTS_I2)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// {98898143-96E2-11D3-A1D0-444553540000}
/*static*/ const IID CPhonerEvent::IID_IPhonerEvent =
{ 0x98898143, 0x96E2, 0x11D3, { 0xA1, 0xD0, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00 } };

BEGIN_INTERFACE_MAP(CPhonerEvent, CCmdTarget)
	INTERFACE_PART(CPhonerEvent, IID_IPhonerEvent, Dispatch)
END_INTERFACE_MAP()



// ==========================================================================
// class CPhoner
CPhoner::CPhoner()
: ICPhoner()
{
	DWORD	Flags = COINIT_MULTITHREADED;
	HRESULT	hRes = CoInitializeEx(NULL, Flags);

	CreateDispatch("Phoner.CPhoner");	

	m_pPhonerEvent = new CPhonerEvent();
	m_pPhonerEvent->SetPhonerInstance(this);

	LPUNKNOWN pUnkSink = m_pPhonerEvent->GetIDispatch(FALSE);

	// Establish a connection between source and sink.
			// m_pUnkSrc is IUnknown of server obtained by CoCreateInstance().
			// m_dwCookie is a cookie identifying the connection, and is needed
			// to terminate the connection.
	AfxConnectionAdvise(m_lpDispatch, CPhonerEvent::IID_IPhonerEvent, pUnkSink, FALSE, &m_Cookie);
}

CPhoner::~CPhoner()
{
	LPUNKNOWN pUnkSink = m_pPhonerEvent->GetIDispatch(FALSE);

	AfxConnectionUnadvise(m_lpDispatch, CPhonerEvent::IID_IPhonerEvent, pUnkSink, FALSE, m_Cookie);

	delete m_pPhonerEvent;
}

BOOL CPhoner::GetCallInfo(long CallID, TCallState& CallState, TDirection& Direction, LPTSTR CallerID, LPTSTR CalledID)
{
	BSTR bCallerID;
	BSTR bCalledID;

	CString cCallerID;
	CString cCalledID;

    bCallerID = cCallerID.AllocSysString(); 
	bCalledID = cCalledID.AllocSysString(); 
	long Ret = ICPhoner::GetCallInfo(CallID, (long*)&CallState, (long*)&Direction, &bCallerID, &bCalledID);
	cCallerID = bCallerID;
	cCalledID = bCalledID;

	SysFreeString(bCallerID);
	SysFreeString(bCalledID);

	if (Ret)
	{
		if (CallerID)
			strcpy(CallerID, cCallerID);
		if (CalledID)
			strcpy(CalledID, cCalledID);
		return TRUE;
	}
	else
		return FALSE;
}

void CPhoner::GetState(long CallID, LPTSTR StateString)
{
	if (StateString)
	{
		VARIANT	Variant;
		CString	s;

		Variant.vt = VT_BSTR;
		Variant.bstrVal = s.AllocSysString();
		ICPhoner::GetState(CallID, &Variant);
		s = Variant.bstrVal;
		strcpy(StateString, s);
		SysFreeString(Variant.bstrVal);
	}
}

void CPhoner::GetDirection(long CallID, LPTSTR DirectionString)
{
	if (DirectionString)
	{
		VARIANT	Variant;
		CString	s;

		Variant.vt = VT_BSTR;
		Variant.bstrVal = s.AllocSysString();
		ICPhoner::GetDirection(CallID, &Variant);
		s = Variant.bstrVal;
		strcpy(DirectionString, s);
		SysFreeString(Variant.bstrVal);
	}
}

void CPhoner::GetCallerID(long CallID, LPTSTR CallerID)
{
	if (CallerID)
	{
		VARIANT	Variant;
		CString	s;

		Variant.vt = VT_BSTR;
		Variant.bstrVal = s.AllocSysString();
		ICPhoner::GetCallerID(CallID, &Variant);
		s = Variant.bstrVal;
		strcpy(CallerID, s);
		SysFreeString(Variant.bstrVal);
	}
}

void CPhoner::GetCalledID(long CallID, LPTSTR CalledID)
{
	if (CalledID)
	{
		VARIANT	Variant;
		CString	s;

		Variant.vt = VT_BSTR;
		Variant.bstrVal = s.AllocSysString();
		ICPhoner::GetCallerID(CallID, &Variant);
		s = Variant.bstrVal;
		strcpy(CalledID, s);
		SysFreeString(Variant.bstrVal);
	}
}

void CPhoner::GetRecordedWAVE(long CallID, LPTSTR FileName)
{
	if (FileName)
	{
		VARIANT	Variant;
		CString	s;

		Variant.vt = VT_BSTR;
		Variant.bstrVal = s.AllocSysString();
		ICPhoner::GetCallerID(CallID, &Variant);
		s = Variant.bstrVal;
		strcpy(FileName, s);
		SysFreeString(Variant.bstrVal);
	}
}

/*virtual*/ void CPhoner::OnChangeState(int CallID)
{
	UNREFERENCED_PARAMETER(CallID);

	char s[255];

	GetState(CallID, s);
}

/*virtual*/ void CPhoner::OnFilePlayed()
{
}

/*virtual*/ void CPhoner::OnDTMF(int CallID, BYTE Digit)
{
	UNREFERENCED_PARAMETER(CallID);
	UNREFERENCED_PARAMETER(Digit);
}