#if !defined( _PHONER_H_ )
#define _PHONER_H_


#define _WIN32_DCOM
#ifndef _AFX_NO_OLE_SUPPORT
#include <afxole.h>         // MFC OLE classes
//#include <afxdisp.h>        // MFC Automation classes
#include <Afxctl.h>
#endif // _AFX_NO_OLE_SUPPORT

class CPhoner;

// ==========================================================================
// class ICPhoner
class ICPhoner : public COleDispatchDriver
{
public:
	ICPhoner() {}		// Calls COleDispatchDriver default constructor
	ICPhoner(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ICPhoner(const ICPhoner& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:

// Operations
public:
	void MakeCall(LPCTSTR Number);
	long GetNumberOfCalls();
	long GetCallInfo(long CallID, long* Status, long* Direction, BSTR* CallerID, BSTR* CalledID);
	void DisconnectCall(long CallID);
	void SendSMS(LPCTSTR Number, LPCTSTR Msg);
	void AnswerCall(long CallID);
	BOOL GetWindowEnabled();
	void SetWindowEnabled(BOOL bNewValue);
	void SendDTMF(long CallID, LPCTSTR DTMF);
	CString GetDisconnectReason(long CallID);
	void MakeCallOver(LPCTSTR Number, LPCTSTR MSN);
	void SendWAVE(long CallID, LPCTSTR FileName);
	void GetState(long CallID, VARIANT* StateString);
	void GetDirection(long CallID, VARIANT* DirectionString);
	void GetCallerID(long CallID, VARIANT* CallerID);
	void GetCalledID(long CallID, VARIANT* CalledID);
	void GetRecordedWAVE(long CallID, VARIANT* FileName);
};

// ==========================================================================
// class CPhonerEvent
class CPhonerEvent : public CCmdTarget
{
	DECLARE_DYNCREATE(CPhonerEvent)

public:
	CPhonerEvent();           // protected constructor used by dynamic creation
	virtual ~CPhonerEvent();

	void SetPhonerInstance(CPhoner* pPhoner);

// Attributes
public:
	static const IID IID_IPhonerEvent;

// Operations	

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPhonerEvent)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
protected:	
	void OnChangeState(int CallID);
	void OnFilePlayed();
	void OnDTMF(int CallID, BYTE Digit);

	// Generated message map functions
	//{{AFX_MSG(CPhonerEvent)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CPhonerEvent)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()

private:
	CPhoner*	m_pPhoner;
};


// ==========================================================================
// class CPhoner
class CPhoner : public ICPhoner
{
public:
	CPhoner();
	~CPhoner();

	enum TCallState
	{
		Idle			= 0x00000000,
		Offering		= 0x00000001,
		Connecting		= 0x00000002,
		Connected		= 0x00000003,
		Disconnecting	= 0x00000004,
		Disconnected	= 0x00000005,
		Parked			= 0x00000006,
		Hold			= 0x00000007,
		Holding			= 0x00000008,
		Unholding		= 0x00000009,
		Conferenced		= 0x0000000A
	};

	enum TDirection
	{
		Incoming		= 0x00000000,
		Outgoing		= 0x00000001
	};

	BOOL GetCallInfo(long CallID, TCallState& CallState, TDirection& Direction, LPTSTR CallerID, LPTSTR CalledID);
	void GetState(long CallID, LPTSTR StateString);
	void GetDirection(long CallID, LPTSTR DirectionString);
	void GetCallerID(long CallID, LPTSTR CallerID);
	void GetCalledID(long CallID, LPTSTR CalledID);
	void GetRecordedWAVE(long CallID, LPTSTR FileName);

	virtual void OnChangeState(int CallID);
	virtual void OnFilePlayed();
	virtual void OnDTMF(int CallID, BYTE Digit);

private:
	CPhonerEvent*	m_pPhonerEvent;
	DWORD			m_Cookie;
};

#endif // _PHONER_H_
